// Aufgabe 1:
int[][] data = {{1, 1, 1},
                {1, 1, 5},
                {1, 2, 5},
                {5, 2, 1},
                {3, 2, 4},
                {4, 5, 1},
                {5, 1, 2},
                {2, 3, 3},
                {1, 3, 4}};

// Aufgabe 2:
// Die Variable itemAmount gibt an, wie viele Datentupel es gibt.
// Die Variable attributeAmount gibt an, wie viele Attribute ein Datentupel besitzt.
int itemAmount = data.length;
int attributeAmount = data[0].length;

// Aufgabe 3:
float[][] points = new float[itemAmount][2];

// Radius der Kreise, die die Datenpunkte darstellen.
float radius = 20;

// In diesem Array werden die Farben der Punkte gespeichert
color[] colors = new color[itemAmount];
color buttonColor = color(94, 147, 191);
color darkButtonColor = color(8, 112, 163);

// Diese beiden Variablen benötigt man für die Funktion drag()
boolean clickedMaster = false;
boolean[] clicked = new boolean[itemAmount];

// Diese Funktion verteilt die Punkte zufällig auf dem Canvas
public float[] createRandomPointPosition()
{
  float[] point = new float[2];
  for (int i = 0; i < 2; i++)
  {
    point[i] = random(400);
  }
  return point;
}

// Aufgabe 4: 
public float getPointDistance(float[] point1, float[] point2)
{
  float distance = 0;
  for (int i = 0; i < 2; i++)
  {
    distance += pow((point1[i] - point2[i]), 2);
  }
  return sqrt(distance);
}

// Aufgabe 5:
public float getDataDistance(int[] data1, int[] data2)
{
  float distance = 0;
  for (int i = 0; i < attributeAmount; i++)
  {
    distance += pow((data1[i] - data2[i]),2);
  }
  return sqrt(distance) * 100;
}

//Das ist eine Musterlösung für die Funktion, die ihr in der letzten Stunde geschrieben habt. Ihr könnt auch gerne eure Lösung verwenden!
public void drag(int i)
{
  if (mouseX>=points[i][0] - radius  && mouseY >= points[i][1] - radius && mouseX<=points[i][0] + radius  && mouseY <= points[i][1] + radius && mousePressed && !clickedMaster)
    {
      clicked[i] = true;
      clickedMaster = true;
    }
    if (clicked[i]&&mousePressed)
    {
      points[i][0] = mouseX;
      points[i][1] = mouseY;
    }
    else if (!mousePressed)
    {
      clicked[i] = false;
      clickedMaster = false;
    }
}

// Aufgabe 7: 
public void setColor()
{
  for (int i = 0; i < itemAmount; i++)
  {
    colors[i] = color(0,255,0);
    
    // Grenze, ab dem ein Fehler gezählt wird
    int threshold = 100;
    // Zählt ausgehend von einem Punkt die fehlerhaften Punkte
    int errorCounter = 0;
    
    for (int j = 0; j < itemAmount; j++)
    {
      if (abs(getPointDistance(points[i], points[j]) - getDataDistance(data[i], data[j])) > threshold)
      {
        errorCounter++;
      }
    }
    colors[i] = getColor(errorCounter);
  }
}

public color getColor(int errorCounter) {
  if (errorCounter > 0) {
    int red = ceil((float(errorCounter)/float(itemAmount))*255);
    int green = ceil((1-(float(errorCounter)/float(itemAmount)))*255);
    
    return color(red, green, 0);
  }
  return color(0,255,0);
}

public void setup()
{
  size(800, 600);
  
  //create an array of data items and points and initially set their color
  for (int i = 0; i < itemAmount; i++)
  {
    points[i] = createRandomPointPosition();
  }
  setColor();
}

public void draw()
{
  background(255);
  noStroke();
  fill(buttonColor);
  if (mouseX>= 300  && mouseY >= 500 && mouseX<= 300 + 220  && mouseY <= 500 + 90)
  {
    fill(darkButtonColor);
    if (mousePressed)
    {
      setColor();
    }
  }
  rect(300, 500, 220, 90, 10);
  fill(255);
  text("evaluieren", 380, 545);
  
  for (int i = 0; i < itemAmount; i++)
  { 
    fill(colors[i]);  
    circle(points[i][0],points[i][1],2*radius);
    fill(0);
    
    // Aufgabe 6:    
    for (int j = 0; j < attributeAmount; j++)
    {
      text(data[i][j], points[i][0], points[i][1] + j * 10);
    }
    
    drag(i);
  }
}
